<template>
	<view class="page-wrap" v-bind:style="{paddingBottom:paddingBottom+'px'}">
		<uni-card margin="0" :is-shadow="true">
			<u--form labelPosition="left" labelWidth="auto" labelAlign="center" :model="model">
				<u-form-item label="层级：" prop="LEVEL_SHOW" borderBottom>
					<u--input v-model="model.LEVEL_SHOW" border="none" slot="right" inputAlign="right" disabled
						disabledColor="fff"></u--input>
				</u-form-item>
				<u-form-item label="执行时间：" prop="execTime" borderBottom>
					<u--input v-model="model.execTime" border="none" slot="right" inputAlign="right" disabled
						disabledColor="fff"></u--input>
				</u-form-item>
				<u-form-item label="制定人：" prop="Nav_LiableUser.NAME" borderBottom>
					<u--input v-model="model.Nav_LiableUser.NAME" border="none" slot="right" inputAlign="right" disabled
						disabledColor="fff"></u--input>
				</u-form-item>
				<u-form-item label="辨识区域：" prop="Areas" borderBottom>
				</u-form-item>
				<u--textarea autoHeight v-model="model.Areas" border="none" inputAlign="right" disabled
					disabledColor="#fff"></u--textarea>
				<u-form-item label="辨识要求：" prop="Nav_Request.NAME" borderBottom>
				</u-form-item>
				<u--textarea autoHeight v-model="model.Nav_Request.NAME" border="none" inputAlign="right" disabled
					disabledColor="#fff"></u--textarea>
				<u-form-item label="辨识对象：" prop="identifyings" borderBottom>
					<u--input autoHeight v-model="model.Identifyings" border="none" inputAlign="right" disabled
						disabledColor="#fff"></u--input>
				</u-form-item>
				<view class="upload-title">附件</view>
				<full-upload v-model="model.Nav_Files" :listProp='listPropUpload'
					:listPropVal='listPropValUpload' :isShowBtn="false"></full-upload>
			</u--form>
		</uni-card>
		<u-sticky offset-top="20">
			<view class="sub-form">
				<view class="sub-form-wrap">
					<u--form labelPosition="left" labelWidth="auto" labelAlign="center" errorType="border-bottom"
						ref="sForm">
						<u-collapse :border="false" accordion>
							<uni-card style="margin-bottom: 16px;" margin="0" spacing="0" :is-shadow="false"
								v-for="(item, index) in model.Nav_Detail">
								<u-collapse-item
									:title="index + 1 + '. ' + item['Nav_Area'].NAME+' - '+transLevel(item['LEVEL'])+' - '+item.Nav_User.NAME">
									<u-form-item label="辨识人员" prop="allUsers" borderBottom>
										<u--input disabled disabledColor="#fff" v-html="item.allUsers" border="none"
											slot="right"></u--input>
									</u-form-item>
								</u-collapse-item>
							</uni-card>
						</u-collapse>
					</u--form>
				</view>
			</view>
		</u-sticky>
		<audit-process :show="showAudit" @close="handleCloseAudit" :dataSource="auditData" />
		<check-action v-if="isLoadOK && tableKey === '1'&&isAudit==='true' " :okApi="okApi" :refuseApi="refuseApi"
			:dataSource="$store.state.auditModel"></check-action>
		<view class="bottom-button">
			<button type="primary" class="bottom" v-if='isLoadOK&&tableKey==1&&!isAudit'
				@click="onTableBtnAgree">确认</button>
		</view>
	</view>
</template>

<script>
	import {
		initFilter,
		extendRule,
		extendInclude
	} from '../../../../utils/common'

	import {
		getRequest
	}
	from '../../../../services/apply/FOServices/FOServices'
	import '../../../../utils/showMsg.js'
	import color from '../../../../uni_modules/uview-ui/libs/config/color'
	import config from '../../../../config/common'

	export default {
		data() {
			return {
				model: {
					Nav_Team: "",
					Nav_Request: "",
					Nav_LiableUser: ""
				},
				isAudit: false,
				TaskID: "",
				tableKey: '0',
				isLoadOK: false,
				paddingBottom: '170',
				auditData: [],
				showAudit: false,
				orgId : uni.getStorageSync('orgId'),
				listPropUpload: ['TASK_ID'],
				listPropValUpload: [],
			}
		},
		onLoad(option) {
			this.model.ID = option.ID;
			this.TaskID = option.taskID;
			this.tableKey = option.tableKey ? option.tableKey : '0';
			this.isAudit = option.isAudit;
			this.okApi = option.okApi;
			this.refuseApi = option.refuseApi;
			this.loadData();
		},
		methods: {
			loadData() {
				const json = initFilter(this.orgId, "", "CODE", 1)
				extendRule(json, 'ID', 1, this.model.ID);
				extendInclude(json, 'Nav_Request');
				extendInclude(json, 'Nav_Identifyings.Nav_Identifying');
				extendInclude(json, 'Nav_Files.Nav_ImgFile.Nav_File');
				extendInclude(json, 'Nav_Detail.Nav_Users.Nav_User');
				extendInclude(json, 'Nav_Detail.Nav_User');
				extendInclude(json, 'Nav_Detail.Nav_Area');
				extendInclude(json, 'Nav_LiableUser');
				extendInclude(json, 'Nav_Areas.Nav_Area');
				getRequest(json, "/HM/RiskTask/Get").then(res => {
					this.model = res
					//数据组装
					let strAreas = ''
					if (res.Nav_Areas && res.Nav_Areas.length > 0) {
						for (let i = 0; i < res.Nav_Areas.length; i++) {
							strAreas += (strAreas.length > 0 ? " " : "") + res.Nav_Areas[
								i].Nav_Area.NAME;
						}
					}
					let strIdentifyings = ''
					if (res.Nav_Identifyings && res.Nav_Identifyings.length > 0) {
						for (let i = 0; i < res.Nav_Identifyings.length; i++) {
							strIdentifyings += (strIdentifyings.length > 0 ? " " : "") + res.Nav_Identifyings[
								i].Nav_Identifying.NAME;
						}
					}
					let strAllUsers = ''
					if (res.Nav_Detail && res.Nav_Detail.length > 0) {
						for (let i = 0; i < res.Nav_Detail.length; i++) {
							for (let j = 0; j < res.Nav_Detail[i].Nav_Users.length; j++) {
								if (res.Nav_Detail[i].Nav_Users[j].DEAL_STATUS == 0) {
									strAllUsers += (strAllUsers.length > 0 ? " " : "") +
										"<text style='color:red'> " +
										res.Nav_Detail[i].Nav_Users[j].Nav_User.NAME + " </text>&nbsp;";
								} else {
									strAllUsers += (strAllUsers.length > 0 ? "&nbsp;" : "") + res.Nav_Detail[
										i].Nav_Users[j].Nav_User.NAME + "&nbsp;";
								}
							}
							this.model.Nav_Detail[i].allUsers = strAllUsers;
						}
					}
					this.model.LEVEL_SHOW = this.renderLevel(this.model.LEVEL);
					this.model.execTime = uni.$u.timeFormat(this.model.START_TIME, 'yyyy-mm-dd') + '~' + uni.$u
						.timeFormat(this.model.END_TIME, 'yyyy-mm-dd');
					this.model.Areas = strAreas;
					this.model.Identifyings = strIdentifyings;
					this.isLoadOK = true;
				})
			},
			renderLevel(level) {
				let str = '';
				if (level == undefined) {
					return str;
				}
				if (level.indexOf('0') >= 0) {
					str += '部门 ';
				}
				if (level.indexOf('1') >= 0) {
					str += '车间 ';
				}
				if (level.indexOf('2') >= 0) {
					str += '班组 ';
				}
				if (level.indexOf('3') >= 0) {
					str += '公司 ';
				}
				return str;
			},
			transLevel(level) {
				if (level == 0) {
					return '部门 ';
				}
				if (level == 1) {
					return '车间 ';
				}
				if (level == 2) {
					return '班组 ';
				}
				if (level == 3) {
					return '公司 ';
				}
			},
			onTableBtnAgree() {
				let json = {};
				json.ID = this.model.ID;
				json.TaskID = this.TaskID;
				getRequest(json, "/HM/HMRiskTask/UserSignin").then(res => {
					if (res) {
						uni.$showMsgFunc('操作成功!', () => {
							uni.navigateBack()
						}, 'success', 1000)
					}
				})
			},
			loadAuditData() {
				const json = initFilter(this.orgId, this.model.ID, "CODE", 1)
				return new Promise((resolve, reject) => {
					getRequest(json, "/PF/Approve/GetApproveInfo").then(res => {
						if (res) {
							if (res && res[0].Nav_ApproveDetails.length > 0) {
								resolve(res)
							}
						} else {
							uni.showToast({
								title: '暂无审批数据',
								icon: 'none'
							})
						}
					}).catch(err => {
						reject(err)
					})
				})
			},
			handleCloseAudit() {
				this.showAudit = false
			}
		},
		async onNavigationBarButtonTap() {
			const res = await this.loadAuditData()
			if (res) {
				this.auditData = res
				this.showAudit = true
			}
		}
	}
</script>

<style>
	@import url("@/style/css/editTemplate.css");
</style>